## this one is commonly used with AM_PATH_PYTHONDIR ...
dnl AM_CHECK_PYMOD(MODNAME [,SYMBOL [,ACTION-IF-FOUND [,ACTION-IF-NOT-FOUND]]])
dnl Check if a module containing a given symbol is visible to python.
AC_DEFUN(AM_CHECK_PYMOD,
[AC_REQUIRE([AM_PATH_PYTHON])
py_mod_var=`echo $1['_']$2 | sed 'y%./+-%__p_%'`
AC_MSG_CHECKING(for ifelse([$2],[],,[$2 in ])python module $1)
AC_CACHE_VAL(py_cv_mod_$py_mod_var, [
ifelse([$2],[], [prog="
import sys
try:
        import $1
except ImportError:
        sys.exit(1)
except:
        sys.exit(0)
sys.exit(0)"], [prog="
import $1
$1.$2"])
if $PYTHON -c "$prog" 1>&AC_FD_CC 2>&AC_FD_CC
  then
    eval "py_cv_mod_$py_mod_var=yes"
  else
    eval "py_cv_mod_$py_mod_var=no"
  fi
])
py_val=`eval "echo \`echo '$py_cv_mod_'$py_mod_var\`"`
if test "x$py_val" != xno; then
  AC_MSG_RESULT(yes)
  ifelse([$3], [],, [$3
])dnl
else
  AC_MSG_RESULT(no)
  ifelse([$4], [],, [$4
])dnl
fi
])

dnl a macro to check for ability to create python extensions
dnl  AM_CHECK_PYTHON_HEADERS([ACTION-IF-POSSIBLE], [ACTION-IF-NOT-POSSIBLE])
dnl function also defines PYTHON_INCLUDES
AC_DEFUN([AM_CHECK_PYTHON_HEADERS],
[AC_REQUIRE([AM_PATH_PYTHON])
AC_MSG_CHECKING(for headers required to compile python extensions)
dnl deduce PYTHON_INCLUDES
py_prefix=`$PYTHON -c "import sys; print sys.prefix"`
py_exec_prefix=`$PYTHON -c "import sys; print sys.exec_prefix"`
PYTHON_INCLUDES="-I${py_prefix}/include/python${PYTHON_VERSION}"
if test "$py_prefix" != "$py_exec_prefix"; then
  PYTHON_INCLUDES="$PYTHON_INCLUDES -I${py_exec_prefix}/include/python${PYTHON_VERSION}"
fi
AC_SUBST(PYTHON_INCLUDES)
dnl check if the headers exist:
save_CPPFLAGS="$CPPFLAGS"
CPPFLAGS="$CPPFLAGS $PYTHON_INCLUDES"
AC_TRY_CPP([#include <Python.h>],dnl
[AC_MSG_RESULT(found)
$1],dnl
[AC_MSG_RESULT(not found)
$2])
CPPFLAGS="$save_CPPFLAGS"
])

AC_DEFUN([AM_TRY_LINK_PYTHON], [
  if test -z "$PYTHON_LDFLAGS"; then
    try_link_python_save_LDFLAGS="$LDFLAGS"
    LDFLAGS="$LDFLAGS $2"
    AC_CHECK_LIB($PYTHON_FULL_NAME, $1, PYTHON_LDFLAGS="$2", )
    LDFLAGS="$try_link_python_save_LDFLAGS"
  fi
])

dnl SC - this is a quick hack to get library options if python-config is available.
AC_DEFUN([AM_CHECK_PYTHON_LIBS], [
  AC_REQUIRE([AM_PATH_PYTHON])
  AC_PATH_PROG(PYTHON_CONFIG_PROG, python-config)
  PYTHON_FULL_NAME="python${PYTHON_VERSION}"
  if test -z "$PYTHON_CONFIG_PROG" ; then
    PYTHON_TRY_LDFLAGS="-l${PYTHON_FULL_NAME}"
  else
    PYTHON_TRY_LDFLAGS="`$PYTHON_CONFIG_PROG`"
  fi
  dnl SC - use 3 different functions to avoid cache tests
  AM_TRY_LINK_PYTHON(Py_Initialize, [$PYTHON_TRY_LDFLAGS])
  AM_TRY_LINK_PYTHON(Py_Finalize, [$PYTHON_TRY_LDFLAGS -lutil])
  AM_TRY_LINK_PYTHON(Py_IsInitialized, [$PYTHON_TRY_LDFLAGS -lutil -lpthread])
  if test -z "$PYTHON_LDFLAGS" ; then
    AC_MSG_ERROR([Unable to determine proper Python link flags.])
  else
    LDFLAGS="$LDFLAGS $PYTHON_LDFLAGS"
  fi
])

dnl SWIG macro
AC_DEFUN(AC_PROG_SWIG, [
  AC_PATH_PROG(SWIG, swig)
  if test -z "$SWIG" ; then
    AC_MSG_ERROR([SWIG not found.  This is required for Python wrapper generation.])
  fi
])
